
// Sorting doubles  using a priority queue. 
// Written by Ed Hong
// UWT Tacoma, Jan. 22, 2003.

import java.lang.*;

public class PQSort {
	public static
	void	main(String[] argv)
	{ // load and print a sample array
		int	n;

		double [] X;
		if (argv.length==1) {
		 X = ArrayIOUtils.LoadDoubleArray(argv[0]);
		}
		else {
		    X = ArrayIOUtils.LoadDoubleArray();
		 // X = ArrayIOUtils.LoadDoubleArray("testset.txt");
		}
		 System.out.println("Input:");
		ArrayIOUtils.printDoubleArray(X);

		 sort(X);
		 
		 System.out.println("");
		 System.out.println("Sorted Output:");
		ArrayIOUtils.printDoubleArray(X);
	}

    // sorts X using a priority queue. 
    public static void  sort(double X[]) {
	int n;
	n = X.length;
	Mypriorityqueue pq = new Mypriorityqueue();
	for (int i=0; i < n; i++)
	    pq.insertItem(X[i], new Double(X[i]));
	
	for (int i=0; i < n; i++)
	    X[i] = ((Double) pq.removeMin()).doubleValue();	    
    }
}
